{**************************************************************************}
{*      ணࠬ MCI File Packer 1.06                                     *}
{*     䠩,   Norton|Volkov Commanders.                   *}
{*    ਬ  ARJ, LZH, PAK, ZIP.                                *}
{*       '⮢㢠    ⨯ *}
{* .                                                                *}
{*                                   (C) 1994,96 Andrew O. Porokhnyak     *}
{**************************************************************************}
{*  Borland Pascal 7.0                                11.10.96            *}
{*  :   1.06  ~[0023]       ⠭ ॢ:    Wed  03-23-1994     *}
{**************************************************************************}
PROGRAM MCI_Packer;
{$M 8192, 4096, 4096 }

USES
    Dos,
    TPCrt;

CONST
    wOrigX          = 11;
    wOrigY          =  5;
    wSizeX          = 60;
    wSizeY          = 14;
    wShadX          =  2;
    wShadY          =  1;
    MaxArcType      =  6;
    MaxArcOptn      =  2;
{    nmbArc          = 4; }

TYPE
    TArcType        = ( _ARJ_, _LZH_, _PAK_, _RAR_, _UC2_, _ZIP_ );
    TObjType        = (
        _InL_, _RB_Typ_, _CB_Opt_, _ST_Opt_,
        _Bt_OK_, _Bt_Sav_, _Bt_Can_
    );
    TPoint          = RECORD
        X, Y        : byte;
    END;
    TArcOStr        = ARRAY[1..MaxArcOptn] OF string[3];
    TArcOptn        = RECORD
        wArcOpt     : word;
        sArcOpt     : string[31];
    END;

VAR
    _EntryScreen    : ARRAY[0..1999] OF word;
    b1, b2          : byte;
    w               : word;
    ch              : char;
    OK              : boolean;
    SaveAttr        : byte;
    SaveCursPos,
    SaveCursShp     : word;
    s, ss           : string[79];
    FName           : string[63];
    _ARC_Var        : TArcType;
    ATT             : file OF char;
    PGM             : file;

CONST
    P_EntryScreen   : pointer = @_EntryScreen;
    _Done           : byte = 0;
    _null           : STRING[7]='';
    CurrObj         : TObjType = _InL_;
    ObjSize         : ARRAY[ _InL_ .. _Bt_Can_ ] OF TPoint = (
        (X:6; Y:1),   { _InL_ }
        (X:24; Y: 6),   { _RB_Typ_ }
        (X:23; Y:4),   { _CB_Opt_ }
        (X:24; Y:2 ),   { _ST_Opt_ }
        (X:8; Y:1),     { _Bt_OK_  [ Pack ] }
        (X:12; Y:1),    { _Bt_Sav_  [ Save Cfg ] }
        (X:10; Y:1)     { _Bt_Can_ [ Cancel ] }
    );
    ObjOrig         : ARRAY[ _InL_ .. _Bt_Can_ ] OF TPoint = (
        (X:6; Y:3),     { _InL_ }
        (X:6; Y:5),     { _RB_Typ_ }
        (X:33; Y:5),    { _CB_Opt_ }
        (X:33; Y:9),    { _ST_Opt_ }
        (X:13; Y:(wSizeY-2)),   { _Bt_OK_ }
        (X:13+8+3; Y:(wSizeY-2)),   { _Bt_Sav_ }
        (X:13+20+6; Y:(wSizeY-2))    { _Bt_Can_ }
    );
    ARC_Ops         : ARRAY[0..1] OF string[15] = (
        'Move File',
        'Store Path'
    );
    ArcName         : string[39] = '';
    ARC_Start       : ARRAY[ _ARJ_ .. _ZIP_ ] OF string[7] = (
        'ARJ A',
        'LHA A',
        'PAK A',
        'RAR A',
        'UC A',
        'PKZIP'
    );
    ARC_Ext         : ARRAY[ _ARJ_ .. _ZIP_ ] OF string[3] = (
        'ARJ',
        'LZH',
        'PAK',
        'RAR',
        'UC2',
        'ZIP'
    );
    ARC_ListCh      : ARRAY[ _ARJ_ .. _ZIP_ ] OF char = (
        '!',
        '@',
        '@',
        '@',
        '@',
        '@'
    );
    ARC_OptStr      : ARRAY[ _ARJ_ .. _ZIP_ ] OF TArcOStr = (
        (#1'M',  '-e'),                 {ARJ}
        (#1'M',  '-x'),                 {LZH}
        (#1'M',  ''  ),                 {PAK}
        (#1'M',  ''  ),                 {RAR}
        ('-M',   ''  ),                  {UC2}
        ('-m',   '-P')                   {ZIP}
    );
    _FileOfs        : word = $DEFA; {- Search 0xfade in binary, then -}
                                    {- change to offset of itself. Sorry... -}
    ARCType         : TArcType = _ZIP_;
    ARCOptn         : ARRAY[ _ARJ_ .. _ZIP_ ] OF TArcOptn = (
        (wArcOpt:0; sArcOpt:''),
        (wArcOpt:0; sArcOpt:''),
        (wArcOpt:0; sArcOpt:''),
        (wArcOpt:0; sArcOpt:''),
        (wArcOpt:0; sArcOpt:''),
        (wArcOpt:0; sArcOpt:'')
    );

{$I AOPLIB02.INC}
{$I AOPMOUSE.INC}

PROCEDURE _Set_AOP_TTY( AXLeft, AWidth, AYUp, AYDown, AColor : byte ); FAR;
EXTERNAL;
PROCEDURE _Reset_TTY; FAR; EXTERNAL;
{$L MCI_01.OBJ}

PROCEDURE Show_Help;
BEGIN
    writeln('MCI File Packer 1.07   (C) 1994,98 AOP');
    DisplayBanner;
    writeln(' ':8,'Written by Andrew O. Porokhnyak'#13#10);
    writeln(' ':8,'Pack selected files under Norton Commander 3.0 & Volkov',
        ' Commander 4.00'#13#10);
    writeln('Replace MCI.EXE in your Commander directory and use F9FS',
        ' to send selected');
    writeln('files into archive (.ARJ, .LZH, .PAK, .ZIP).');
    writeln('Or, insert in VC.MNU');
    writeln(' ':8,'x:   Pack sel file');
    writeln(' ':8,'     @mci @!');
    HALT;
END; {=====================================================================}

FUNCTION EditStrXY(X, Y, MaxL : byte; VAR s : string; up : boolean) : word;
VAR ch, cc : char;
BEGIN
    NormalCursor;
    REPEAT
        GotoXY( X+Length( s ), Y );
        ch := ReadKey;
        IF ch=#0 THEN cc:=ReadKey ELSE cc:=#0;
        IF up THEN ch := UpCase( ch );
        CASE ch of
        #8 : Delete( s, Length( s ), 1 );
        ' '..'~' : BEGIN
            IF Length( s )<MaxL THEN s := s + ch;
        END;
        END; {--- CASE ---}
        FastWriteWindow( s+' ', Y, X, $30);
    UNTIL (ch IN [#9,#13,#27]) OR ((cc=#15) AND (ch=#0));
    HiddenCursor;
    EditStrXY := word( cc ) SHL 8 + byte( ch );
END; {=====================================================================}

PROCEDURE Process_ArcName( ed : boolean );
VAR ww : word;
BEGIN
    WITH ObjOrig[_InL_] DO BEGIN
    FastWriteWindow( 'Arc Name', Y, X, $7F);
    FastFillWindow( 40, ' ', Y, X+10, $30 );
    FastWriteWindow( ArcName, Y, X+10, $30);
    IF NOT ed THEN Exit;
    ww := EditStrXY( X+10, Y, SizeOf( ArcName )-1, ArcName, true );
    CASE ww OF
        $001B: _Done := 2;
        $0009,$000D: BEGIN
            CurrObj := _RB_Typ_;
            IF ((ww=$000D) AND (ArcName>'')) THEN
                 _Done := 1;         { 1.07, only name launch }
        END;
        $0F00: CurrObj := _Bt_Can_;
    END; {---CASE---}
    END; {--- WITH ---}
END; {=====================================================================}

PROCEDURE Process_ArcOStr( ed : boolean );
VAR ww : word;
BEGIN
    WITH ObjOrig[_ST_Opt_] DO BEGIN
    FastWriteWindow( 'Additional Options', Y, X+1, $7F);
    FastFillWindow( 23, ' ', Y+1, X{+11}, $30 );
    FastWriteWindow( ARCOptn[ ARCType ].sArcOpt, Y+1, X{+11}, $30);
    IF NOT ed THEN Exit;
    ww := EditStrXY( X {+11}, Y+1, 22, ARCOptn[ ARCType ].sArcOpt, false );
    CASE ww OF
        $001B: _Done := 2;
        $0009, $000D : CurrObj := _Bt_OK_;
        $0F00 : CurrObj := _CB_Opt_;
    END; {---CASE---}
    END; {--- WITH ---}
END; {=====================================================================}

PROCEDURE Process_ArcOption( ed : boolean );
    PROCEDURE DrawView;
    VAR b : byte;
    BEGIN
        WITH ObjOrig[_CB_Opt_] DO BEGIN
        FOR b:=0 TO 1 DO BEGIN
            IF (ARCOptn[ ARCType ].wArcOpt AND word(1 SHL b)) <> 0
                THEN s:='[x]'
                ELSE s:='[ ]';
            FastWriteWindow(s+'  '+ARC_Ops[b],
                Y+b+1, X+2, $70);
        END;
        END; {---WITH---}
    END;
VAR _i1 : integer;
    _w1 : word;
    cc : char;
BEGIN
    FrameChars := 'ĳ';
    WITH ObjOrig[_CB_Opt_] DO BEGIN
    FrameWindow( wOrigX+X-1, wOrigY+Y-1, wOrigX+X+ObjSize[_CB_Opt_].X-2,
        wOrigY+Y+ObjSize[_CB_Opt_].Y-2, $70, $7F, ' Arc Option ' );
    DrawView;
    IF NOT ed THEN Exit;
    _i1 := 0;
    REPEAT
        ChangeAttributeWindow( 16, Y+_i1+1, X+2, $7E );
        ch := ReadKey;
        ChangeAttributeWindow( 16, Y+_i1+1, X+2, $70 );
        IF ch=#0 THEN cc := ReadKey ELSE cc := #0;
        IF ch = #27 THEN BEGIN _Done := 2; Exit; END;
        IF ch IN [#13, ' '] THEN BEGIN
            _w1 := word( 1 ) SHL _i1;
            IF (ARCOptn[ ArcType ].wArcOpt AND _w1) <> 0
                THEN ARCOptn[ ArcType ].wArcOpt :=
                     ARCOptn[ ArcType ].wArcOpt AND NOT _w1
                ELSE ARCOptn[ ArcType ].wArcOpt :=
                     ARCOptn[ ArcType ].wArcOpt OR _w1;
            DrawView;
        END;
        CASE cc OF
         #$48 : Dec( _i1 );
         #$50 : Inc( _i1 );
        END;
        IF _i1<0 THEN _i1 := MaxArcOptn - 1;
        IF _i1>=MaxArcOptn THEN _i1 := 0;
    UNTIL (ch IN [#9,#13]) OR ((ch=#0) AND (cc=#15));
    IF ch=#0 THEN CurrObj :=  _RB_Typ_ ELSE CurrObj := _ST_Opt_;
    END; {---WITH---}
END; {=====================================================================}

PROCEDURE Process_ArcType( ed : boolean );
VAR _i1, _i2 : integer;
    cc : char;
    _col, _row      : BYTE;
    i, j        : BYTE;
    PROCEDURE DrawView;
    BEGIN
        i:=1;
        j:=2;
        WITH ObjOrig[_RB_Typ_] DO BEGIN
        FOR _ARC_Var := _ARJ_ TO _ZIP_ DO BEGIN
            IF _ARC_Var = ARCType THEN s:='('#7')' ELSE s:='( )';
            FastWriteWindow(s+'  '+ARC_Ext[_ARC_Var],
                Y+i, X+j, $70);
            Inc(i);
            IF (i>_row) THEN BEGIN
                i:=1;
                INC(j, 12);
            END;
        END;
        END; {---WITH---}
    END;
BEGIN
    _row:=ObjSize[_RB_Typ_].Y-2;
    _col:=((MaxArcType-1) DIV _row) + 1;
    FrameChars := 'ĳ';
    WITH ObjOrig[_RB_Typ_] DO BEGIN
    FrameWindow( wOrigX+X-1, wOrigY+Y-1, wOrigX+X+ObjSize[_RB_Typ_].X-2,
        wOrigY+Y+ObjSize[_RB_Typ_].Y-2, $70, $7F, ' Arc Type ' );
    DrawView;
    IF NOT ed THEN Exit;
    _i1 := integer( ARCType ); {0..MaxArcType-1}
    REPEAT
        i:=(_i1 MOD _row) + 1;
        j:=(_i1 DIV _row)*12 + 2;
        ChangeAttributeWindow( 9, Y+i, X+j, $7E );
        ch := ReadKey;
        ChangeAttributeWindow( 9, Y+i, X+j, $70 );
        IF ch=#0 THEN cc := ReadKey ELSE cc := #0;
        IF ch = #27 THEN BEGIN _Done := 2; Exit; END;
        IF ch IN [#13, ' '] THEN BEGIN
            ArcType := TArcType( _i1 );
            DrawView;
            Process_ArcOption( false );
            Process_ArcOStr( false );
        END;
        CASE cc OF
         #$48 : Dec( _i1 );             {Up}
         #$50 : Inc( _i1 );             {Down}
         #$47 : _i1:=0;                 {Home}
         #$4F : _i1:=MaxArcType-1;      {End}
         #$4B : BEGIN                   {Right}
              DEC(_i1, _row);         
              END;
         #$4D : BEGIN                   {Left}
              INC(_i1, _row);
              IF _i1>=MaxArcType THEN _i1 := MaxArcType-1;
              END;
        END;
        IF _i1<0 THEN _i1 := MaxArcType - 1;
        IF _i1>=MaxArcType THEN _i1 := 0;
    UNTIL (ch IN [#9,#13]) OR ((ch=#0) AND (cc=#15));
    IF ch=#0 THEN CurrObj := _InL_ ELSE CurrObj := _CB_Opt_;
    END; {---WITH---}
END; {=====================================================================}

PROCEDURE Process_OK_Bt( ed : boolean );
VAR _i1, _i2 : integer;
    cc : char;
BEGIN
    WITH ObjOrig[_Bt_OK_] DO BEGIN
    FastWriteWindow( '[ Pack ]', Y, X, $70);
    IF NOT ed THEN Exit;
    REPEAT
        ChangeAttributeWindow( ObjSize[_Bt_OK_].X, Y, X, $30 );
        ch := ReadKey;
        ChangeAttributeWindow( ObjSize[_Bt_OK_].X, Y, X, $70 );
        IF ch=#0 THEN cc := ReadKey ELSE cc := #0;
        IF ch = #27 THEN BEGIN _Done := 2; Exit; END;
        IF ch IN [#13, ' '] THEN BEGIN
            IF (ArcName = '') THEN BEGIN
                CurrObj := _InL_; EXIT;
            END;
            _Done := 1;
        END;
    UNTIL (ch IN [#9,#13]) OR ((ch=#0) AND (cc=#15));
    IF ch=#0 THEN CurrObj := _ST_Opt_ ELSE CurrObj := _Bt_Sav_;
    END; {---WITH---}
END; {=====================================================================}

PROCEDURE Process_Sav_Bt( ed : boolean );
VAR _i1, _i2 : integer;
    dt, tm : word;
    cc : char;
BEGIN
    WITH ObjOrig[_Bt_Sav_] DO BEGIN
    FastWriteWindow( '[ Save Cfg ]', Y, X, $70);
    IF NOT ed THEN Exit;
    REPEAT
        ChangeAttributeWindow( ObjSize[_Bt_Sav_].X, Y, X, $30 );
        ch := ReadKey;
        ChangeAttributeWindow( ObjSize[_Bt_Sav_].X, Y, X, $70 );
        IF ch=#0 THEN cc := ReadKey ELSE cc := #0;
        IF ch = #27 THEN BEGIN _Done := 2; Exit; END;
        IF ch IN [#13, ' '] THEN BEGIN
            Assign( PGM, ParamStr( 0 ) );
            Reset( PGM, 1 );
            Move( PGM, _i2, SizeOf( _i2 ) );  {---! Non-Portable !---}
            ASM     {--- '⮢ FDate ---}
                MOV     AX, 5700h
                MOV     BX, _i2
                INT     21h
                MOV     tm, CX
                MOV     dt, DX
            END;
            Seek( PGM, _FileOfs + 2 );
            BlockWrite(PGM, ARCType, SizeOf(ARCType)+SizeOf(ARCOptn), _i1);
            Close( PGM );
            Reset( PGM, 1 );
            ASM     {---  FDate ---}
                MOV     AX, 5701h
                MOV     BX, _i2
                MOV     CX, tm
                MOV     DX, dt
                INT     21h
            END;
            Close( PGM );
            CurrObj := _Bt_OK_; EXIT;
        END;
    UNTIL (ch IN [#9,#13]) OR ((ch=#0) AND (cc=#15));
    IF ch=#0 THEN CurrObj := _Bt_OK_ ELSE CurrObj := _Bt_Can_;
    END; {---WITH---}
END; {=====================================================================}

PROCEDURE Process_Can_Bt( ed : boolean );
VAR _i1, _i2 : integer;
    cc : char;
BEGIN
    WITH ObjOrig[_Bt_Can_] DO BEGIN
    FastWriteWindow( '[ Cancel ]', Y, X, $70);
    IF NOT ed THEN Exit;
    REPEAT
        ChangeAttributeWindow( ObjSize[_Bt_Can_].X, Y, X, $30 );
        ch := ReadKey;
        ChangeAttributeWindow( ObjSize[_Bt_Can_].X, Y, X, $70 );
        IF ch=#0 THEN cc := ReadKey ELSE cc := #0;
        IF ch IN [#13, #27, ' '] THEN BEGIN
            _Done := 2; Exit;
        END;
    UNTIL (ch IN [#9,#13]) OR ((ch=#0) AND (cc=#15));
    IF ch=#0 THEN CurrObj := _Bt_Sav_ ELSE CurrObj := _InL_;
    END; {---WITH---}
END; {=====================================================================}

BEGIN {}
    {---  饭  - ,    ---}
    IF ((PARAMCOUNT=0) OR (PARAMSTR(1)='Socha')) THEN BEGIN
        FName := ParamStr( 0 );
        Delete( FName, Length( FName )-3, 4 );
        FName := FName + '.ATT';
    END ELSE
        FName:=PARAMSTR(1);

    Assign( ATT, FName );
    {$I-} Reset( ATT ); {$I+}
    OK := IOResult = 0;
    IF (NOT OK) OR (FileSize( ATT )<1) THEN Show_Help;

    {--- ᨬ  ( ) ---}
    _ms_off;

    {---   䠩 .ATT   ASCII 10 ---}
    WHILE NOT EOF( ATT ) DO BEGIN
        read( ATT, ch );
        IF ch=',' THEN BEGIN
            Seek( ATT, FilePos( ATT )-1 );
            ch := #10;
            write( ATT, ch );
        END;
    END;
    Close( ATT );

    {--- '⮢ ,    ---}
    SaveAttr := TextAttr;
    GetCursorState( SaveCursPos, SaveCursShp );
    HiddenCursor;
    OK := SaveWindow( wOrigX,wOrigY, wOrigX+wSizeX+wShadX,
        wOrigY+wSizeY+wShadY, false, P_EntryScreen );

    {---  ୥  ---}
    Window( wOrigX,wOrigY, wOrigX+wSizeX-1,wOrigY+wSizeY-1 );
    TextAttr := $70;
    ClrScr;
    FOR b1:=wOrigY+1 TO wOrigY+wSizeY-1 DO
        ChangeAttribute( wShadX, b1, wOrigX+wSizeX, $08 );
    ChangeAttribute( wSizeX, wOrigY+wSizeY, wOrigX+wShadX, $08 );
    FrameChars := 'Ȼͺ';
    FrameWindow( wOrigX+3, wOrigY+1, wOrigX+wSizeX-4,wOrigY+wSizeY-2
        , $70, $7E, ' MCI File Packer 1.06 ' );
    FastFillWindow( wSizeX-8, '', wSizeY-3, 5, $70 );
    FastWriteWindow( '', wSizeY-3, 4, $70 );
    FastWriteWindow( '', wSizeY-3, wSizeX-3, $70 );

    {--- ࢨ  ' ---}
    Process_ArcName( false );
    Process_ArcType( false );
    Process_ArcOption( false );
    Process_ArcOStr( false );
    Process_OK_Bt( false );
    Process_Sav_Bt( false );
    Process_Can_Bt( false );

    {---   ஬ ---}
    REPEAT
        CASE CurrObj OF
        _InL_ :     Process_ArcName( true );
        _RB_Typ_ :  Process_ArcType( true );
        _CB_Opt_ :  Process_ArcOption( true );
        _ST_Opt_ :  Process_ArcOStr( true );
        _BT_OK_   :  Process_OK_Bt( true );
        _BT_Sav_  :  Process_Sav_Bt( true );
        _BT_Can_  :  Process_Can_Bt( true );
        END; {---CASE---}
    UNTIL _Done > 0;

    {--- ⮢    ---}
    s := ARC_Start[ ARCType ];
    IF ARCType = _ARJ_ THEN BEGIN
        w := ARCOptn[ ARCType ].wArcOpt;
        ARCOptn[ ARCType ].wArcOpt := (w AND $FFFE) OR ((NOT w) AND $0001);
    END;
    FOR b1:=1 TO MaxArcOptn DO BEGIN
        w := word( 1 ) SHL (b1-1);
        IF ((ARCOptn[ ARCType ].wArcOpt AND w) <> 0)
            THEN BEGIN
            ss := ARC_OptStr[ ARCType ][b1];
            IF ss[1] = #1 THEN BEGIN
                { b2 := Pos(' ', s);
                Inc( b2 ); }
                b2 := 5;
                { WHILE (s[b2] <> ' ') AND (b2<Length(s)) DO Delete(s, b2,
                1);}
                Delete( s, b2, 1 );
                Insert( Copy(ss, 2, 10), s, b2 );
            END ELSE s := s + ' ' + ss;
        END;
    END;
    CASE ARCType OF     {Special cases}
        _RAR_:
            s:=s+' -std';
        _UC2_:
            _null:='>nul';
    END;
    s := s + ' ' + ARCOptn[ ARCType ].sArcOpt+' '+ArcName+' ';

    IF _Done = 1 THEN BEGIN
        SetBlink( true );
        FastFillWindow( wSizeX-10, ' ', wSizeY-2, 6, $7 );
        FastCenter( ' Executing... ', wSizeY-3, $FE);
        FastWriteWindow( s +ARC_ListCh[ ARCType ]+FName, wSizeY-2, 6, $7 );

        {---   ---}
        _Set_AOP_TTY( 15, 49, 6, 13, $70 );
        SwapVectors;
        Exec( GetEnv('COMSPEC'), '/C '+s+' '+ARC_ListCh[ ARCType ]+FName+
            _null);
        SwapVectors;
        _Reset_TTY;
        FastCenter( ' Finished ... ', wSizeY-3, $FE);

        w:=0;
        REPEAT
            Delay( 10 );
            Inc( w );
        UNTIL (w>300) OR KeyPressed;
        WHILE KeyPressed DO ch:=ReadKey;
    END;

    {---  䠩 .ATT ---}
    Assign( ATT, FName );
    Erase( ATT );

    {---  ,    ---}
    IF OK THEN RestoreWindow( wOrigX,wOrigY, wOrigX+wSizeX+wShadX,
        wOrigY+wSizeY+wShadY, false, P_EntryScreen );
    TextAttr := SaveAttr;
    RestoreCursorState( SaveCursPos, SaveCursShp );
END. {}
